- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnPluginData Class Reference

# OpenMaya - API module for common classes | FunctionSet classes

Search for all occurrences

## Detailed Description

User defined data function set for dependency node data.

All user defined data that is to be passed between nodes in the dependency graph must be derived from MPxData. The use of this class is closely linked to the use of MPxData, MFnPluginData, MDataHandle, and MTypeId.

In order to use user defined data, one must first create an instance of the MTypeId class that is initialized with a unique id tag. Then create a new class derived from MPxData to hold the user-defined data, As well as a helper class derived from MPxData that can create instances of the new derived type.

For data of this type that needs to be passed into a plug, one would get an MDataHandle for the attribute that uses the type. This would result in a call to the MPxData helper class that would create an instance of the type inside the MDataHandle. The MDataHandle::data method can then be used to get an get an MObject for the user defined data and this should be used to initialize an instance of MFnPluginData. Then the MFnPluginData::data method can be used to get an MPxData pointer, which can be safely cast to a pointer of the user defined type. The data can be updated through this pointer, after which the MDataHandle::setClean method is used to complete the operation.

To receive data of this type from a plug, an MDataHandle for the attribute that uses the new data type is created. The MDataHandle::type method should be used to ascertain that it contains kPlugin data. Then the MDataHandle::data method is used to get an MObject for the user defined data and this should be used to initialize an instance of MFnPluginData. The MFnPluginData::typeId method can be used to ascertain that the data is in fact of the user defined type. Then the MFnPluginData::data method can be used to get an MPxData pointer, which can be safely cast to a pointer to the user defined type.

Examples:

  apiMeshCreator.cpp, apiMeshShape.cpp, blindComplexDataCmd.cpp, and blindDoubleDataCmd.cpp.

`#include <MFnPluginData.h>`

Inheritance diagram for MFnPluginData:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnPluginData ()
| Destructor.
| MFnPluginData ()
| Default constructor.
| MFnPluginData (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
MTypeId | typeId (MStatus *ReturnStatus=NULL) const
| Return the unique MTypeId of the user defined data that is held by this instance.
MPxData * | data (MStatus *ReturnStatus=NULL)
| Return a pointer to the user defined data held in this instance.
const MPxData * | constData (MStatus *ReturnStatus=NULL) const
| Return a constant pointer to the user defined data held in this instance.
MObject | create (const MTypeId &id, MStatus *ReturnStatus=NULL)
| Create an instance of MPluginData and initialize it to represent user defined data of the given type.
| MFnPluginData (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

MFnPluginData | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnPluginData | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kPluginData.

Reimplemented from MFnData.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnPluginData".

Reimplemented from MFnData.

MTypeId typeId | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the unique MTypeId of the user defined data that is held by this instance.

Parameters:

  [out] | ReturnStatus | kSuccess if the instance is attached to an MObject and kFailure otherwise

Returns:
  The unique MTypeId of the data held in this instance

MPxData * data | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return a pointer to the user defined data held in this instance.

Parameters:

  [out] | ReturnStatus | kSuccess if the instance is attached to an MObject and kFailure otherwise

Returns:
  A pointer to the MPxData base class for the user defined data

const MPxData * constData | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return a constant pointer to the user defined data held in this instance.

Parameters:

  [out] | ReturnStatus | kSuccess if the instance is attached to an MObject and kFailure otherwise

Returns:
  A constant pointer to the MPxData base class for the user defined data

MObject create | ( | const MTypeId & | id,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Create an instance of MPluginData and initialize it to represent user defined data of the given type.

Parameters:

  [in] | id | the unique MTypeId of the user defined data class derived from MPxData.
  [out] | ReturnStatus | kSuccess if the create suceeds, and kFailure otherwise

Returns:
  An MObject that represents an instance of the user defined data type. This will be set to MObject::kNullObj if the create failes.

Examples:
  apiMeshCreator.cpp, and apiMeshShape.cpp.

MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData
MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData MFnPluginData